"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class TumourSample(ProtocolElement):
    """
    A tumour sample
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "LDPCode",
        "labSampleId",
        "sampleId",
        "tumourId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import participant as participant_1_1_0

        return {
            "diseaseType": participant_1_1_0.diseaseType,
            "preparationMethod": participant_1_1_0.PreparationMethod,
            "product": participant_1_1_0.Product,
            "programmePhase": participant_1_1_0.ProgrammePhase,
            "source": participant_1_1_0.SampleSource,
            "tissueSource": participant_1_1_0.TissueSource,
            "tumourContent": participant_1_1_0.TumourContent,
            "tumourType": participant_1_1_0.TumourType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import participant as participant_1_1_0

        return {
            "org.gel.models.participant.avro.diseaseType": participant_1_1_0.diseaseType,
            "org.gel.models.participant.avro.PreparationMethod": participant_1_1_0.PreparationMethod,
            "org.gel.models.participant.avro.Product": participant_1_1_0.Product,
            "org.gel.models.participant.avro.ProgrammePhase": participant_1_1_0.ProgrammePhase,
            "org.gel.models.participant.avro.SampleSource": participant_1_1_0.SampleSource,
            "org.gel.models.participant.avro.TissueSource": participant_1_1_0.TissueSource,
            "org.gel.models.participant.avro.TumourContent": participant_1_1_0.TumourContent,
            "org.gel.models.participant.avro.TumourType": participant_1_1_0.TumourType,
            "org.gel.models.participant.avro.TumourSample": participant_1_1_0.TumourSample,
        }

    __slots__ = [
        "LDPCode",
        "labSampleId",
        "sampleId",
        "tumourId",
        "clinicalSampleDateTime",
        "diseaseSubType",
        "diseaseType",
        "morphologyICD",
        "morphologySnomedCT",
        "morphologySnomedRT",
        "preparationMethod",
        "product",
        "programmePhase",
        "source",
        "tissueSource",
        "topographyICD",
        "topographySnomedCT",
        "topographySnomedRT",
        "tumourContent",
        "tumourType",
    ]

    def __init__(
        self,
        LDPCode,
        labSampleId,
        sampleId,
        tumourId,
        clinicalSampleDateTime=None,
        diseaseSubType=None,
        diseaseType=None,
        morphologyICD=None,
        morphologySnomedCT=None,
        morphologySnomedRT=None,
        preparationMethod=None,
        product=None,
        programmePhase=None,
        source=None,
        tissueSource=None,
        topographyICD=None,
        topographySnomedCT=None,
        topographySnomedRT=None,
        tumourContent=None,
        tumourType=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_1_0.TumourSample model.

        :param LDPCode:
            LDP Code (Local Delivery Partner)
        :type LDPCode: str
        :param labSampleId:
            Lab sample identifier
        :type labSampleId: int
        :param sampleId:
            Sample identifier (e.g, LP00012645_5GH))
        :type sampleId: str
        :param tumourId:
            Identifier of each one of the tumours for a participant
        :type tumourId: str
        :param clinicalSampleDateTime:
            The time when the sample was recieved. In the format
            YYYY-MM-DDTHH:MM:SS+0000
        :type clinicalSampleDateTime: None | str
        :param diseaseSubType:
            Disease subtype
        :type diseaseSubType: None | str
        :param diseaseType:
            Disease type
        :type diseaseType: None | diseaseType
        :param morphologyICD:
            Tumour morphology as defined by ICD (at least one morphology
            definition by either ICD, Snomed CT or Snomed RT must be
            provided)
        :type morphologyICD: None | str
        :param morphologySnomedCT:
            Tumour morphology as defined by Snomed CT (at least one morphology
            definition by either ICD, Snomed CT or Snomed RT must be
            provided)
        :type morphologySnomedCT: None | str
        :param morphologySnomedRT:
            Tumour morphology as defined by Snomed RT (at least one morphology
            definition by either ICD, Snomed CT or Snomed RT must be
            provided)
        :type morphologySnomedRT: None | str
        :param preparationMethod:
            The preparation method
        :type preparationMethod: None | PreparationMethod
        :param product:
            Product of the sample
        :type product: None | Product
        :param programmePhase:
            Genomics England programme phase
        :type programmePhase: None | ProgrammePhase
        :param source:
            Source of the sample
        :type source: None | SampleSource
        :param tissueSource:
            The tissue source
        :type tissueSource: None | TissueSource
        :param topographyICD:
            Tumour topography as defined by ICD (at least one topography
            definition by either ICD, Snomed CT or Snomed RT must be
            provided)
        :type topographyICD: None | str
        :param topographySnomedCT:
            Tumour topography as defined by Snomed CT (at least one topography
            definition by either ICD, Snomed CT or Snomed RT must be
            provided)
        :type topographySnomedCT: None | str
        :param topographySnomedRT:
            Tumour topography as defined by Snomed RT (at least one topography
            definition by either ICD, Snomed CT or Snomed RT must be
            provided)
        :type topographySnomedRT: None | str
        :param tumourContent:
            Tumour content
        :type tumourContent: None | TumourContent
        :param tumourType:
            Tumor type
        :type tumourType: None | TumourType
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.1.0"
